Fs = 100000;                  % Sampling frequency
T = 1/Fs;                     % Sample time
L = 1024;                     % Length of signal
t = (0:L-1)*T;                % Time vector
% Sum of a 10000 Hz sinusoid and a 15000 Hz sinusoid
x = sin(2*pi*10000*t)+ sin(2*pi*15000*t);
% Sinusoids plus noise
y = x + randn(size(t));
% Plot sinals.
figure; plot(Fs*t(1:1024),x(1:1024))
title('Clear Signal')
xlabel('time (milliseconds)')
figure; plot(Fs*t(1:1024),y(1:1024))
title('Signal Corrupted with Zero-Mean Random Noise')
xlabel('time (milliseconds)')
NFFT = 2^nextpow2(L); % Next power of 2 from length of y
Y = fft(y,NFFT)/L;
X = fft(x,NFFT)/L;
f = Fs/2*linspace(0,1,NFFT/2+1);
% Plot single-sided amplitude spectrum.
figure; plot(f,2*abs(Y(1:NFFT/2+1))) 
title('Single-Sided Amplitude Spectrum of y(t)')
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
figure; plot(f,2*abs(X(1:NFFT/2+1))) 
title('Single-Sided Amplitude Spectrum of x(t)')
xlabel('Frequency (Hz)')
ylabel('|X(f)|')